﻿/* --- FMfindRepl_PalR.jsx ------ UTF-8 -----------------------------------------------------------
              Palette and Call-back functions, also ancillary function for the UI
Comment       to be included in FMfindRepl.jsx
History       2021-03-03
*/

KLD_F.PalRegEx = function () { //==================================================================
/*            Set up the ancillary palette for setting up a regular expression
Arguments     -
Returns       The visible palette window
Called by     ButtonRegex
Calling       InsertEditItem, FillRegexLists, VerifyRegEx
Comment       A Help button could use
              KLD_F.OpenWebURL ("http://www.regular-expressions.info/");
History       2020-12-29
*/
wPalR  = new Window("palette", undefined, undefined);  // title set in PalR
/*
  try { wPalR  = new Window("palette", KLD_F.UItxt.wPalR.@title, undefined); }
  catch (e) {
    KLD_F.Message ("E", KLD_F.UItxt.wPalF.@txt01, "PaletteR", e.message));
    return;
  }
*/
  wPalR.text = KLD_F.APP_NAME + " [v" + KLD_F.APP_VERSION + "] — " + KLD_F.UItxt.wPalR.@title

  wPalR.location = [wPalF.location.x, wPalF.location.y + 120];
  wPalR.alignChildren = ["left","top"];
  wPalR.spacing = 10;
  wPalR.margins = 5;

  wPalR.st0 = wPalR.add("statictext", undefined, KLD_F.UItxt.wPalR.@st0);

// --------------------------------------------------------------------------------- Title group  1
  wPalR.g1a  = wPalR.add ("group", undefined, undefined);
  wPalR.g1a.st1 = wPalR.g1a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g1ast1);
  wPalR.g1a.st1.preferredSize.width = 205;
  wPalR.g1a.st2 = wPalR.g1a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g1ast2);
  wPalR.g1a.st2.preferredSize.width = 205;;
  wPalR.g1a.st3 = wPalR.g1a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g1ast3);
  wPalR.g1a.st3.preferredSize.width = 205;;

// ----------------------------------------------------------------------------------- Main group 1
  wPalR.g1b  = wPalR.add ("group", undefined, undefined);
  wPalR.g1b.alignChildren = ["left","top"];
  wPalR.g1b.margins = 0;
    wPalR.g1b.lstChars = wPalR.g1b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g1b.lstChars.preferredSize = [205, 80];

    wPalR.g1b.lstAnchor = wPalR.g1b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g1b.lstAnchor.preferredSize = [205, 80];

    wPalR.g1b.lstSynChars = wPalR.g1b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g1b.lstSynChars.preferredSize = [205, 80];

// --------------------------------------------------------------------------------- Title group  2
  wPalR.g2a  = wPalR.add ("group", undefined, undefined);
  wPalR.g2a.st4 = wPalR.g2a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g2ast4);
  wPalR.g2a.st4.preferredSize.width = 205;;
  wPalR.g2a.st5 = wPalR.g2a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g2ast5);
  wPalR.g2a.st5.preferredSize.width = 205;;
  wPalR.g2a.st6 = wPalR.g2a.add("statictext", undefined, KLD_F.UItxt.wPalR.@g2ast6);
  wPalR.g2a.st6.preferredSize.width = 205;;

// ----------------------------------------------------------------------------------- Main group 2
  wPalR.g2b  = wPalR.add ("group", undefined, undefined);
  wPalR.g2b.alignChildren = ["left","top"];
  wPalR.g2b.margins = 0;
    wPalR.g2b.lstMatch = wPalR.g2b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g2b.lstMatch.preferredSize = [205, 80];

    wPalR.g2b.lstWhite = wPalR.g2b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g2b.lstWhite.preferredSize = [205, 80];

    wPalR.g2b.lstSymbols = wPalR.g2b.add("listbox", undefined, undefined, {numberOfColumns: 2, showHeaders: false});
    wPalR.g2b.lstSymbols.preferredSize = [205, 80];

// ---------------------------------------------------------------------- Regular expression set up
  wPalR.g3 = wPalR.add("group", undefined, undefined);
  wPalR.g3.alignChildren = ["left","top"];
  wPalR.g3.spacing = 10;
  wPalR.g3.margins = 5;

  wPalR.g3.st1 = wPalR.g3.add("statictext", undefined, KLD_F.UItxt.wPalR.@g3st1);
  wPalR.g3.st1.preferredSize.width = 80;

  wPalR.g3.eReg = wPalR.g3.add("edittext", undefined, undefined, {multiline: true});
  wPalR.g3.eReg.text = "";
  wPalR.g3.eReg.graphics.font = "Consolas:14";
  wPalR.g3.eReg.preferredSize = [430, 60];

  wPalR.g3.gv = wPalR.g3.add("group", undefined, undefined);
  wPalR.g3.gv.preferredSize.height = 60;
  wPalR.g3.gv.orientation = "column";
  wPalR.g3.gv.alignChildren = ["fill", "fill"];
  wPalR.g3.gv.btnWrap = wPalR.g3.gv.add("button", undefined, KLD_F.UItxt.wPalR.@g3gvbtnWrap);
  wPalR.g3.gv.btnWrap.preferredSize.width = 100;
  wPalR.g3.gv.btnTest = wPalR.g3.gv.add("button", undefined, KLD_F.UItxt.wPalR.@g3gvbtnTest);
  wPalR.g3.gv.btnTest.preferredSize.width = 100;

// -------------------------------------------------------------------------------------- Info area
  wPalR.g4 = wPalR.add("group", undefined, undefined);
  wPalR.g4.alignChildren = ["left","top"];
  wPalR.g4.spacing = 10;
  wPalR.g4.margins = 5;

  wPalR.g4.st1 = wPalR.g4.add("statictext", undefined, KLD_F.UItxt.wPalR.@g4St1);
  wPalR.g4.st1.preferredSize.width = 80;

  wPalR.g4.eInfo = wPalR.g4.add("edittext", undefined, undefined, {multiline: true});
  wPalR.g4.eInfo.text = "";
  wPalR.g4.eInfo.graphics.font = "Consolas:14";
  wPalR.g4.eInfo.preferredSize = [430, 60];

  wPalR.g4.gv = wPalR.g3.add("group", undefined, undefined);
  wPalR.g4.gv.preferredSize.height = 60;
  wPalR.g4.gv.orientation = "column";
  wPalR.g4.gv.btnTransBack = wPalR.g4.add("button", undefined, KLD_F.UItxt.wPalR.@g4gvbtnTransBack);
  wPalR.g4.gv.btnTransBack.alignment = "bottom";
  wPalR.g4.gv.btnTransBack.preferredSize.width = 100;

// ################################################################################################
// there must not be parameters for externalised callback functions!
// ... if the functions are objects, then the call must not contain () !
// There are no onClick and onDoubleClick for edit fields - Event Listeners not possible either.
// ------------------------------------------------------------------------- behaviour of the lists
  wPalR.g1b.lstChars.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g1b.lstChars, KLD_F.aLstChars, wPalR.g3.eReg);
  };
  wPalR.g1b.lstAnchor.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g1b.lstAnchor, KLD_F.aLstAnchor, wPalR.g3.eReg);
  };
  wPalR.g1b.lstSynChars.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g1b.lstSynChars, KLD_F.aLstSynChars, wPalR.g3.eReg);
  };
  wPalR.g2b.lstMatch.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g2b.lstMatch, KLD_F.aLstMatch, wPalR.g3.eReg);
  };
  wPalR.g2b.lstWhite.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g2b.lstWhite, KLD_F.aLstWhite, wPalR.g3.eReg);
  };
  wPalR.g2b.lstSymbols.onDoubleClick = function () {
    KLD_F.InsertEditItem (wPalR.g2b.lstSymbols, KLD_F.aLstSymbols, wPalR.g3.eReg);
  };
// ----------------------------------------------------------------------- behaviour of the buttons
  wPalR.g3.gv.btnWrap.onClick = function () {
    wPalR.g3.eReg.textselection = "(" + wPalR.g3.eReg.textselection + ")";
  }
  wPalR.g3.gv.btnTest.onClick = function () {
    if (KLD_F.VerifyRegEx (wPalR.g3.eReg.text)) {
      wPalR.g4.eInfo.text = KLD_F.UItxt.wPalR.@msg_01;
      wPalR.g4.eInfo.graphics.foregroundColor = wPalR.g4.eInfo.graphics.newPen (wPalR.g4.eInfo.graphics.PenType.SOLID_COLOR, [0,0,0], 1);
    } else {
      wPalR.g4.eInfo.text = KLD_F.UItxt.wPalR.@msg_02;
      wPalR.g4.eInfo.graphics.foregroundColor = wPalR.g4.eInfo.graphics.newPen (wPalR.g4.eInfo.graphics.PenType.SOLID_COLOR, [1,0,0], 1);
    }
  }
  wPalR.g4.gv.btnTransBack.onClick = function () {
    wPalF.g02.eFindWhat.text = wPalR.g3.eReg.text; // Update main panel
    wPalR.close ();
  }
// ------------------------------------------------------------------------- Final work in dialogue
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstChars,    KLD_F.aLstChars);  // fill arrays from XML file
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstAnchor,   KLD_F.aLstAnchor);
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstSynChars, KLD_F.aLstSynChars);
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstMatch,    KLD_F.aLstMatch);
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstWhite,    KLD_F.aLstWhite);
  KLD_F.FillRegexLists (KLD_F.UItxt.aLstSymbols,  KLD_F.aLstSymbols);

  KLD_F.FillListBox    (wPalR.g1b.lstChars,       KLD_F.aLstChars);
  KLD_F.FillListBox    (wPalR.g1b.lstAnchor,      KLD_F.aLstAnchor);
  KLD_F.FillListBox    (wPalR.g1b.lstSynChars,    KLD_F.aLstSynChars);
  KLD_F.FillListBox    (wPalR.g2b.lstMatch,       KLD_F.aLstMatch);
  KLD_F.FillListBox    (wPalR.g2b.lstWhite,       KLD_F.aLstWhite);
  KLD_F.FillListBox    (wPalR.g2b.lstSymbols,     KLD_F.aLstSymbols);

  wPalR.g3.eReg.active = true;
  wPalR.show();
} //--- end of PalRegEx ><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><><>

KLD_F.DisplayInfoR = function (sText, sColour) { // ===============================================
/*            Display text in the information area
Arguments     sText           The text to be displayed. It may contain line breaks (CTRL+Enter)
              sColour         "black" or "red" - other colours are not defined.
Returns       -
Called by     InsertEditItem
Calling       -
History       2020-12-29
*/
  wPalR.g4.eInfo.text = sText;
  if (sColour == "red") {
    wPalR.g4.eInfo.graphics.foregroundColor = wPalR.g4.eInfo.graphics.newPen (wPalR.g4.eInfo.graphics.PenType.SOLID_COLOR, [1,0,0], 1);
  } else {
    wPalR.g4.eInfo.graphics.foregroundColor = wPalR.g4.eInfo.graphics.newPen (wPalR.g4.eInfo.graphics.PenType.SOLID_COLOR, [0,0,0], 1);
  }
} //--- end of DisplayInfoR -----------------------------------------------------------------------

KLD_F.InsertEditItem = function (oList, asItems, oEdit) { // ======================================
/*            Modify contents of edit field
Arguments     oList           List object providing the index (selected element)
              asItems         Array of items from which the text element is taken for insertion
              oEdit           EditText object (edit field in GUI).
                              The element .textselection may be a real selection or an empty string.
                              If the selection is empty, then the item from the list is inserted.
Returns       -
Called by     PalRegEx
Calling       DisplayInfoR
Used in       FMfindRepl
History       2021-03-04
*/
var a, index, iTab, sItem, sSelection;
  wPalR.g4.eInfo.text = "";                       // clear info area
  if (oEdit != undefined || oEdit != null) {
    index = oList.selection.valueOf();
    iTab = asItems[index].indexOf("¦");
    sItem = asItems[index].substring (iTab+1);
    sSelection = oEdit.textselection;
    if (oEdit.textselection == oEdit.text) {      // append at end of text
      oEdit.text = oEdit.text + sItem;
    } else {                                      // replace selection
      oEdit.textselection = sItem;
    }
    oList.selection.selected = false;
  } else {
    KLD_F.DisplayInfoR (KLD_F.UItxt.FillListBox.@msg_01, "red");
  }
} // --- end InsertEditItem -----------------------------------------------------------------------

KLD_F.FillListBox = function (oListBox, asItems) { // =============================================
/*            Fill list box items from array items
Arguments     oListBox        List object receiving the items
              asItems         Array of items
Returns       -
Called by     PalRegEx
Calling       -
Used in       FMfindRepl
History       2021-03-04
*/
var j, nItems, iTab, sName, sItem;

  nItems = asItems.length;
  for (j = 0; j < nItems; j++) {                  // make a 2-column list
    iTab = asItems[j].indexOf("¦");
    sName = asItems[j].substring (0, iTab);
    sItem = asItems[j].substring (iTab+1);
    with (oListBox.add ("item", sName)) {
      subItems[0].text = sItem;
    }
  }

} // --- end FillListBox --------------------------------------------------------------------------

KLD_F.FillRegexLists = function (xArray, aArray) { // = ===========================================
/*            Fill arrays for UI drop-down lists
Called by     PalRegEx
Calling       -
Comment       With the transtion to UI texts in XML file these arrays can not be defined
              with global values.
History       2020-11-17
*/
var c0, c1, j, jComma, n, constant = [];
  aArray.length = 0;                              // clear array
  n = xArray.item.length();                       // number of items
  for (j = 0; j < n; j++) {
    aArray.push (xArray.item[j].toString());
  }
} //--- end of FillFindTypeData -------------------------------------------------------------------
